<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: correlation_tracker.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_6fa195adb58ca7edc2dded7e6bc48796.html">image_processing</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">correlation_tracker.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2015  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_CORRELATION_TrACKER_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_CORRELATION_TrACKER_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;correlation_tracker_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../geometry.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../array2d.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;../image_transforms/assign_image.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;{</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="classdlib_1_1correlation__tracker.html">   18</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1correlation__tracker.html">correlation_tracker</a></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    {</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <a class="code" href="classdlib_1_1correlation__tracker.html">correlation_tracker</a> (</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        ) </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        {</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;            <span class="comment">// Create the cosine mask used for space filtering.</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;            mask = make_cosine_mask();</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            <span class="comment">// Create the cosine mask used for the scale filtering.</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;            scale_cos_mask.resize(get_num_scale_levels());</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">long</span> max_level = get_num_scale_levels()/2;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> k = 0; k &lt; get_num_scale_levels(); ++k)</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            {</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                <span class="keywordtype">double</span> dist = std::abs((<span class="keywordtype">double</span>)k-max_level)/max_level*pi/2;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;                dist = std::min(dist, pi/2);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;                scale_cos_mask[k] = std::cos(dist);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;            }</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        }</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> image_type&gt;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keywordtype">void</span> start_track (</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            <span class="keyword">const</span> image_type&amp; img,</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1drectangle.html">drectangle</a>&amp; p</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        )</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        {</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;            DLIB_CASSERT(p.is_empty() == <span class="keyword">false</span>,</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                <span class="stringliteral">&quot;\t void correlation_tracker::start_track()&quot;</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t You can&#39;t give an empty rectangle.&quot;</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            );</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;            B.set_size(0,0);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <a class="code" href="classdlib_1_1point__transform__affine.html">point_transform_affine</a> tform = inv(make_chip(img, p, F));</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; F.size(); ++i)</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;                fft_inplace(F[i]);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            make_target_location_image(tform(center(p)), G);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            A.resize(F.size());</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; F.size(); ++i)</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            {</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;                A[i] = pointwise_multiply(G, F[i]);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;                B += squared(real(F[i]))+squared(imag(F[i]));</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            }</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            position = p;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160; </div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            <span class="comment">// now do the scale space stuff</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            make_scale_space(img, Fs);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; Fs.size(); ++i)</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;                fft_inplace(Fs[i]);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            make_scale_target_location_image(get_num_scale_levels()/2, Gs);</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            Bs.set_size(0);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            As.resize(Fs.size());</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; Fs.size(); ++i)</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;            {</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;                As[i] = pointwise_multiply(Gs, Fs[i]);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;                Bs += squared(real(Fs[i]))+squared(imag(Fs[i]));</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            }</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        }</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_filter_size (</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 128/2; } <span class="comment">// must be power of 2</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_num_scale_levels(</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 32; }  <span class="comment">// must be power of 2</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_scale_window_size (</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 23; }</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordtype">double</span> get_regularizer_space (</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.001; }</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">double</span> get_nu_space (</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.025;}</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keywordtype">double</span> get_regularizer_scale (</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.001; }</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keywordtype">double</span> get_nu_scale (</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.025;}</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <a class="code" href="classdlib_1_1drectangle.html">drectangle</a> get_position (</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        )<span class="keyword"> const </span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keyword">        </span>{ </div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            <span class="keywordflow">return</span> position;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        }</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160; </div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keywordtype">double</span> get_scale_pyramid_alpha (</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;            <span class="keywordflow">return</span> 1.020;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        }</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> image_type&gt;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keywordtype">double</span> update (</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;            <span class="keyword">const</span> image_type&amp; img,</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1drectangle.html">drectangle</a>&amp; guess</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        )</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        {</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            DLIB_CASSERT(get_position().is_empty() == <span class="keyword">false</span>,</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;                <span class="stringliteral">&quot;\t double correlation_tracker::update()&quot;</span></div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t You must call start_track() first before calling update().&quot;</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            );</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160; </div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1point__transform__affine.html">point_transform_affine</a> tform = make_chip(img, guess, F);</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; F.size(); ++i)</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;                fft_inplace(F[i]);</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160; </div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="comment">// use the current filter to predict the object&#39;s location</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            G = 0; </div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; F.size(); ++i)</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;                G += pointwise_multiply(F[i],conj(A[i]));</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            G = pointwise_multiply(G, reciprocal(B+get_regularizer_space()));</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;            ifft_inplace(G);</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1vector.html">dlib::vector&lt;double,2&gt;</a> pp = max_point_interpolated(real(G));</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160; </div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            <span class="comment">// Compute the peak to side lobe ratio.</span></div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1vector.html">point</a> p = pp;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            <a class="code" href="classdlib_1_1running__stats.html">running_stats&lt;double&gt;</a> rs;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1rectangle.html">rectangle</a> peak = centered_rect(p, 8,8);</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; G.nr(); ++r)</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            {</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> c = 0; c &lt; G.nc(); ++c)</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                {</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                    <span class="keywordflow">if</span> (!peak.contains(<a class="code" href="classdlib_1_1vector.html">point</a>(c,r)))</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                        rs.add(G(r,c).real());</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                }</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;            }</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> psr = (G(p.y(),p.x()).real()-rs.mean())/rs.stddev();</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160; </div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            <span class="comment">// update the position of the object</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            position = translate_rect(guess,tform(pp)-center(guess));</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160; </div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="comment">// now update the position filters</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            make_target_location_image(pp, G);</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            B *= (1-get_nu_space());</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; F.size(); ++i)</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            {</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;                A[i] = get_nu_space()*pointwise_multiply(G, F[i]) + (1-get_nu_space())*A[i];</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                B += get_nu_space()*(squared(real(F[i]))+squared(imag(F[i])));</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            }</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160; </div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160; </div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160; </div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            <span class="comment">// Now predict the scale change</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            make_scale_space(img, Fs);</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; Fs.size(); ++i)</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                fft_inplace(Fs[i]);</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            Gs = 0;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; Fs.size(); ++i)</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;                Gs += pointwise_multiply(Fs[i],conj(As[i]));</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;            Gs = pointwise_multiply(Gs, reciprocal(Bs+get_regularizer_scale()));</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            ifft_inplace(Gs);</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> pos = max_point_interpolated(real(Gs)).y();</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160; </div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            <span class="comment">// update the rectangle&#39;s scale</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            position *= std::pow(get_scale_pyramid_alpha(), pos-(<span class="keywordtype">double</span>)get_num_scale_levels()/2);</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160; </div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160; </div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160; </div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            <span class="comment">// Now update the scale filters</span></div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            make_scale_target_location_image(pos, Gs);</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;            Bs *= (1-get_nu_scale());</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; Fs.size(); ++i)</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            {</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                As[i] = get_nu_scale()*pointwise_multiply(Gs, Fs[i]) + (1-get_nu_scale())*As[i];</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                Bs += get_nu_scale()*(squared(real(Fs[i]))+squared(imag(Fs[i])));</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            }</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160; </div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160; </div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            <span class="keywordflow">return</span> psr;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        }</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160; </div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> image_type&gt;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        <span class="keywordtype">double</span> update (</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            <span class="keyword">const</span> image_type&amp; img</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        )</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        {</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            <span class="keywordflow">return</span> update(img, get_position());</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        }</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160; </div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160; </div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> image_type&gt;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="keywordtype">void</span> make_scale_space(</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            <span class="keyword">const</span> image_type&amp; img,</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            std::vector&lt;<a class="code" href="classdlib_1_1matrix.html">matrix</a>&lt;std::complex&lt;double&gt;,0,1&gt; &gt;&amp; Fs</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structdlib_1_1image__traits.html">image_traits&lt;image_type&gt;::pixel_type</a> pixel_type;</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160; </div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            <span class="comment">// Make an image pyramid and put it into the chips array.</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">long</span> chip_size = get_scale_window_size();</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;            <a class="code" href="classdlib_1_1drectangle.html">drectangle</a> ppp = position*std::pow(get_scale_pyramid_alpha(), -(<span class="keywordtype">double</span>)get_num_scale_levels()/2);</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            <a class="code" href="classdlib_1_1array.html">dlib::array&lt;array2d&lt;pixel_type&gt;</a> &gt; chips;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            std::vector&lt;dlib::vector&lt;double,2&gt; &gt; from_points, to_points;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;            from_points.push_back(<a class="code" href="classdlib_1_1vector.html">point</a>(0,0));</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            from_points.push_back(<a class="code" href="classdlib_1_1vector.html">point</a>(chip_size-1,0));</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;            from_points.push_back(<a class="code" href="classdlib_1_1vector.html">point</a>(chip_size-1,chip_size-1));</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; get_num_scale_levels(); ++i)</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;            {</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                <a class="code" href="classdlib_1_1array2d.html">array2d&lt;pixel_type&gt;</a> chip(chip_size,chip_size);</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160; </div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                <span class="comment">// pull box into chip</span></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                to_points.clear();</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                to_points.push_back(ppp.tl_corner());</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                to_points.push_back(ppp.tr_corner());</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;                to_points.push_back(ppp.br_corner());</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;                transform_image(img,chip,<a class="code" href="classdlib_1_1interpolate__bilinear.html">interpolate_bilinear</a>(),find_affine_transform(from_points, to_points));</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160; </div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                chips.push_back(chip);</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;                ppp *= get_scale_pyramid_alpha();</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;            }</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160; </div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160; </div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;            <span class="comment">// extract HOG for each chip</span></div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;            <a class="code" href="classdlib_1_1array.html">dlib::array&lt;dlib::array&lt;array2d&lt;float&gt;</a> &gt; &gt; hogs(chips.<a class="code" href="classdlib_1_1array.html#a64eac23811ee8278128c020aef2870cb">size</a>());</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; chips.<a class="code" href="classdlib_1_1array.html#a64eac23811ee8278128c020aef2870cb">size</a>(); ++i)</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            {</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;                extract_fhog_features(chips[i], hogs[i], 4);</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                hogs[i].resize(32);</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;                assign_image(hogs[i][31], chips[i]);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;                assign_image(hogs[i][31], mat(hogs[i][31])/255.0);</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;            }</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160; </div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;            <span class="comment">// Now copy the hog features into the Fs outputs and also apply the cosine</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;            <span class="comment">// windowing.</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            Fs.resize(hogs[0].size()*hogs[0][0].size());</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; </div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; hogs[0][0].nr(); ++r)</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;            {</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> c = 0; c &lt; hogs[0][0].nc(); ++c)</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;                {</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;                    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> j = 0; j &lt; hogs[0].size(); ++j)</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;                    {</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;                        Fs[i].set_size(hogs.size());</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;                        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> k = 0; k &lt; hogs.size(); ++k)</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                        {</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;                            Fs[i](k) = hogs[k][j][r][c]*scale_cos_mask[k];</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                        }</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;                        ++i;</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                    }</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                }</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;            } </div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        }</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160; </div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> image_type&gt;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <a class="code" href="classdlib_1_1point__transform__affine.html">point_transform_affine</a> make_chip (</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;            <span class="keyword">const</span> image_type&amp; img,</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;            <a class="code" href="classdlib_1_1drectangle.html">drectangle</a> p,</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            std::vector&lt;<a class="code" href="classdlib_1_1matrix.html">matrix</a>&lt;std::complex&lt;double&gt; &gt; &gt;&amp; chip</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="structdlib_1_1image__traits.html">image_traits&lt;image_type&gt;::pixel_type</a> pixel_type;</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            <a class="code" href="classdlib_1_1array2d.html">array2d&lt;pixel_type&gt;</a> temp;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> padding = 1.4;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            <span class="keyword">const</span> <a class="code" href="structdlib_1_1chip__details.html">chip_details</a> details(p*padding, <a class="code" href="structdlib_1_1chip__dims.html">chip_dims</a>(get_filter_size(), get_filter_size()));</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;            extract_image_chip(img, details, temp);</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160; </div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160; </div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;            chip.resize(32);</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            <a class="code" href="classdlib_1_1array.html">dlib::array&lt;array2d&lt;float&gt;</a> &gt; hog;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            extract_fhog_features(temp, hog, 1, 3,3 );</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; hog.<a class="code" href="classdlib_1_1array.html#a64eac23811ee8278128c020aef2870cb">size</a>(); ++i)</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;                assign_image(chip[i], pointwise_multiply(matrix_cast&lt;double&gt;(mat(hog[i])), mask));</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160; </div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            assign_image(chip[31], temp);</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            assign_image(chip[31], pointwise_multiply(mat(chip[31]), mask)/255.0);</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160; </div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;            <span class="keywordflow">return</span> inv(get_mapping_to_chip(details));</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        }</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160; </div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        <span class="keywordtype">void</span> make_target_location_image (</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1vector.html">dlib::vector&lt;double,2&gt;</a>&amp; p,</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            <a class="code" href="classdlib_1_1matrix.html">matrix</a>&lt;std::complex&lt;double&gt; &gt;&amp; g</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;            g.set_size(get_filter_size(), get_filter_size());</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            g = 0;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;            <a class="code" href="classdlib_1_1rectangle.html">rectangle</a> area = centered_rect(p, 21,21).intersect(get_rect(g));</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = area.top(); r &lt;= area.bottom(); ++r)</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;            {</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> c = area.left(); c &lt;= area.right(); ++c)</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;                {</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;                    <span class="keywordtype">double</span> dist = length(<a class="code" href="classdlib_1_1vector.html">point</a>(c,r)-p);</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;                    g(r,c) = std::exp(-dist/3.0);</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;                }</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;            }</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;            fft_inplace(g);</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;            g = conj(g);</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        }</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160; </div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160; </div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keywordtype">void</span> make_scale_target_location_image (</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> scale,</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;            <a class="code" href="classdlib_1_1matrix.html">matrix</a>&lt;std::complex&lt;double&gt;,0,1&gt;&amp; g</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;            g.set_size(get_num_scale_levels());</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> i = 0; i &lt; g.size(); ++i)</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;            {</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;                <span class="keywordtype">double</span> dist = std::pow((i-scale),2.0);</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;                g(i) = std::exp(-dist/1.000);</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;            }</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;            fft_inplace(g);</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;            g = conj(g);</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        }</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160; </div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;double&gt;</a> make_cosine_mask (</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">long</span> size = get_filter_size();</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;            <a class="code" href="classdlib_1_1matrix.html">matrix&lt;double&gt;</a> temp(size,size);</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;            <a class="code" href="classdlib_1_1vector.html">point</a> cent = center(get_rect(temp));</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; temp.nr(); ++r)</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;            {</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> c = 0; c &lt; temp.nc(); ++c)</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;                {</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;                    <a class="code" href="classdlib_1_1vector.html">point</a> delta = <a class="code" href="classdlib_1_1vector.html">point</a>(c,r)-cent;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;                    <span class="keywordtype">double</span> dist = length(delta)/(size/2.0)*(pi/2);</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;                    dist = std::min(dist*1.0, pi/2);</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160; </div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;                    temp(r,c) = std::cos(dist);</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;                }</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;            }</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;            <span class="keywordflow">return</span> temp;</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        }</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160; </div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160; </div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;        std::vector&lt;matrix&lt;std::complex&lt;double&gt; &gt; &gt; A, F;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;double&gt;</a> B;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160; </div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        std::vector&lt;matrix&lt;std::complex&lt;double&gt;,0,1&gt; &gt; As, Fs;</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;double,0,1&gt;</a> Bs;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        <a class="code" href="classdlib_1_1drectangle.html">drectangle</a> position;</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160; </div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;double&gt;</a> mask;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;        std::vector&lt;double&gt; scale_cos_mask;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160; </div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;        <span class="comment">// G and Gs do not logically contribute to the state of this object.  They are</span></div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="comment">// here just so we can void reallocating them over and over.</span></div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;std::complex&lt;double&gt;</a> &gt; G;</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;std::complex&lt;double&gt;</a>,0,1&gt; Gs;</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    };</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;}</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160; </div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;<span class="preprocessor">#endif // DLIB_CORRELATION_TrACKER_H_</span></div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1array2d_html"><div class="ttname"><a href="classdlib_1_1array2d.html">dlib::array2d</a></div><div class="ttdef"><b>Definition:</b> array2d_kernel.h:18</div></div>
<div class="ttc" id="astructdlib_1_1chip__details_html"><div class="ttname"><a href="structdlib_1_1chip__details.html">dlib::chip_details</a></div><div class="ttdef"><b>Definition:</b> interpolation.h:1555</div></div>
<div class="ttc" id="aclassdlib_1_1rectangle_html"><div class="ttname"><a href="classdlib_1_1rectangle.html">dlib::rectangle</a></div><div class="ttdef"><b>Definition:</b> rectangle.h:19</div></div>
<div class="ttc" id="aclassdlib_1_1vector_html"><div class="ttname"><a href="classdlib_1_1vector.html">dlib::vector&lt; double, 2 &gt;</a></div></div>
<div class="ttc" id="astructdlib_1_1chip__dims_html"><div class="ttname"><a href="structdlib_1_1chip__dims.html">dlib::chip_dims</a></div><div class="ttdef"><b>Definition:</b> interpolation.h:1544</div></div>
<div class="ttc" id="astructdlib_1_1image__traits_html"><div class="ttname"><a href="structdlib_1_1image__traits.html">dlib::image_traits</a></div><div class="ttdef"><b>Definition:</b> generic_image.h:123</div></div>
<div class="ttc" id="aclassdlib_1_1interpolate__bilinear_html"><div class="ttname"><a href="classdlib_1_1interpolate__bilinear.html">dlib::interpolate_bilinear</a></div><div class="ttdef"><b>Definition:</b> interpolation.h:176</div></div>
<div class="ttc" id="aclassdlib_1_1drectangle_html"><div class="ttname"><a href="classdlib_1_1drectangle.html">dlib::drectangle</a></div><div class="ttdef"><b>Definition:</b> drectangle.h:19</div></div>
<div class="ttc" id="aclassdlib_1_1matrix_html"><div class="ttname"><a href="classdlib_1_1matrix.html">dlib::matrix</a></div><div class="ttdef"><b>Definition:</b> matrix/matrix.h:991</div></div>
<div class="ttc" id="aclassdlib_1_1array_html_a64eac23811ee8278128c020aef2870cb"><div class="ttname"><a href="classdlib_1_1array.html#a64eac23811ee8278128c020aef2870cb">dlib::array::size</a></div><div class="ttdeci">unsigned long size() const</div><div class="ttdef"><b>Definition:</b> array_kernel.h:390</div></div>
<div class="ttc" id="aclassdlib_1_1correlation__tracker_html"><div class="ttname"><a href="classdlib_1_1correlation__tracker.html">dlib::correlation_tracker</a></div><div class="ttdef"><b>Definition:</b> correlation_tracker.h:18</div></div>
<div class="ttc" id="aclassdlib_1_1array_html"><div class="ttname"><a href="classdlib_1_1array.html">dlib::array</a></div><div class="ttdef"><b>Definition:</b> array_kernel.h:20</div></div>
<div class="ttc" id="aclassdlib_1_1running__stats_html"><div class="ttname"><a href="classdlib_1_1running__stats.html">dlib::running_stats&lt; double &gt;</a></div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<div class="ttc" id="aclassdlib_1_1point__transform__affine_html"><div class="ttname"><a href="classdlib_1_1point__transform__affine.html">dlib::point_transform_affine</a></div><div class="ttdef"><b>Definition:</b> point_transforms.h:144</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
